unit FormSettings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ActnList;

type
  TfmSettings = class(TForm)
    Label1: TLabel;
    edClientsNum: TEdit;
    Label2: TLabel;
    edProgrammersNum: TEdit;
    Label3: TLabel;
    edA: TEdit;
    Label6: TLabel;
    edCoeffComplexity: TEdit;
    Label7: TLabel;
    edYk: TEdit;
    Label8: TLabel;
    edMu: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    edErrorsNum0: TEdit;
    buCallErrors: TButton;
    Label11: TLabel;
    edY0: TEdit;
    Label12: TLabel;
    edE_aver: TEdit;
    Label13: TLabel;
    edP_newErr: TEdit;
    Label14: TLabel;
    edDT: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    edM: TEdit;
    buAllTime: TButton;
    edTime: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    edK: TEdit;
    buInitParameters: TButton;
    Label19: TLabel;
    edOptimT: TEdit;
    buCallAverCorrectErrorNum: TButton;
    edY_newErr: TEdit;
    Label5: TLabel;
    Label20: TLabel;
    GroupBox2: TGroupBox;
    rbP: TRadioButton;
    rbI: TRadioButton;
    al: TActionList;
    aInitParameters: TAction;
    procedure buAllTimeClick(Sender: TObject);
    procedure buCallErrorsClick(Sender: TObject);
    procedure buCallAverCorrectErrorNumClick(Sender: TObject);
    procedure rbIClick(Sender: TObject);
    procedure rbPClick(Sender: TObject);
    procedure aInitParametersExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmSettings: TfmSettings;

implementation

uses MonteCarloPK;
{$R *.DFM}


procedure TfmSettings.buAllTimeClick(Sender: TObject);
begin
  edTime.Text := FloatToStr( StrToFloat(edDT.Text)* StrToInt(edM.Text) );
end;

procedure TfmSettings.buCallErrorsClick(Sender: TObject);
var y0, yk, a, P_newErr: Double;
    errors: Integer;
begin
//    try
//      P_err := StrToFloat(edP_err.Text);
//      if (P_err < 0) Or (P_err >= 1) then raise Exception.Create('   >= 1  ');
//    except
//      ShowMessage('         < 1');
//      ActiveControl := edP_err;
//      exit;
//    end;

    try
      y0 := StrToFloat(edY0.Text);
      if y0 <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('        ');
      ActiveControl := edY0;
      exit;
    end;

    try
      P_newErr := StrToFloat(edP_newErr.Text);
      if (P_newErr < 0) Or (P_newErr >= 1) then raise Exception.Create('   >= 1  ');
    except
      ShowMessage('            < 1');
      ActiveControl := edP_newErr;
      exit;
    end;

    buAllTimeClick(Sender);
    yk := StrToFloat(edYk.Text);  //   
    a := StrToFloat(edA.Text);  //
    errors := Round(y0/(yk*a));
    edErrorsNum0.Text := IntToStr(errors);



end;

procedure TfmSettings.buCallAverCorrectErrorNumClick(Sender: TObject);
var
 M, errors: Integer;
 optimT, y0, dT, E_aver, P_newErr: Double;
begin
    try
      y0 := StrToFloat(edY0.Text);
      if y0 <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('        ');
      ActiveControl := edY0;
      exit;
    end;

    try
      P_newErr := StrToFloat(edP_newErr.Text);
      if (P_newErr < 0) Or (P_newErr >= 1) then raise Exception.Create('   >= 1  ');
    except
      ShowMessage('            < 1');
      ActiveControl := edP_newErr;
      exit;
    end;

    M := StrToInt(edM.Text);
    dT := StrToFloat(edDT.Text);
    errors := StrToInt(edErrorsNum0.Text);

    E_aver := M*dT*y0*(1-P_newErr);
    edE_aver.Text := FloatToStr(E_aver);


    optimT := errors/(y0*(1-P_newErr));
    edOptimT.Text := FloatToStr(optimT);

end;

procedure TfmSettings.rbIClick(Sender: TObject);
begin
  edY_newErr.Enabled := True;
  edP_newErr.Enabled := False;
  ActiveControl := edY_newErr;

end;

procedure TfmSettings.rbPClick(Sender: TObject);
begin
  edY_newErr.Enabled := False;
  edP_newErr.Enabled := True;
  ActiveControl := edP_newErr;

end;

procedure TfmSettings.aInitParametersExecute(Sender: TObject);
begin
 mkPK.InitializeByFormSettings;
 Close;

end;

end.
